"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  assertUnreachable: true,
  typedValuesOf: true,
  access: true,
  todayAtUTCNoon: true,
  spread: true,
  spreadS: true,
  makeAzureFriendly: true,
  undoAzureFriendly: true,
  setTimeToStartOfDay: true,
  setTimeToMidday: true,
  setTimeToEndOfDay: true,
  todayAtNoon: true,
  isBetween: true,
  isBetweenMidnightAndEndOfDay: true,
  arrayMove: true,
  arrayMoveDropUndefined: true,
  arMoveElDropUndefined: true,
  setMoveElDropUndefined: true,
  isNativeTuple: true,
  LazySymbol: true,
  lazy: true,
  get: true,
  omit: true,
  pick: true
};
exports.LazySymbol = void 0;
exports.access = access;
exports.arMoveElDropUndefined = arMoveElDropUndefined;
exports.arrayMove = arrayMove;
exports.arrayMoveDropUndefined = arrayMoveDropUndefined;
exports.assertUnreachable = assertUnreachable;
Object.defineProperty(exports, "get", {
  enumerable: true,
  get: function () {
    return _get.default;
  }
});
exports.isBetween = isBetween;
exports.isBetweenMidnightAndEndOfDay = isBetweenMidnightAndEndOfDay;
exports.isNativeTuple = isNativeTuple;
exports.lazy = lazy;
exports.makeAzureFriendly = makeAzureFriendly;
Object.defineProperty(exports, "omit", {
  enumerable: true,
  get: function () {
    return _omit.default;
  }
});
Object.defineProperty(exports, "pick", {
  enumerable: true,
  get: function () {
    return _pick.default;
  }
});
exports.setMoveElDropUndefined = setMoveElDropUndefined;
exports.setTimeToStartOfDay = exports.setTimeToMidday = exports.setTimeToEndOfDay = void 0;
exports.spread = spread;
exports.spreadS = spreadS;
exports.todayAtNoon = todayAtNoon;
exports.todayAtUTCNoon = todayAtUTCNoon;
exports.typedValuesOf = void 0;
exports.undoAzureFriendly = undoAzureFriendly;
var tsplus_module_1 = _interopRequireWildcard(require("@fp-ts/data/Option"));
var _dateFns = require("date-fns");
var _fp = require("date-fns/fp");
var _Function = require("@effect-ts-app/core/Function");
Object.keys(_Function).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _Function[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _Function[key];
    }
  });
});
var _utils = require("@effect-ts-app/core/utils");
Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _utils[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _utils[key];
    }
  });
});
var _get = _interopRequireDefault(require("lodash/get.js"));
var _omit = _interopRequireDefault(require("lodash/omit.js"));
var _pick = _interopRequireDefault(require("lodash/pick.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// eslint-disable-next-line import/no-duplicates

// eslint-disable-next-line import/no-duplicates

function assertUnreachable(x) {
  throw new Error("Unknown case " + x);
}
const typedValuesOf = obj => Object.values(obj);
exports.typedValuesOf = typedValuesOf;
function access(t) {
  return key => t[key];
}
function todayAtUTCNoon() {
  const localDate = new Date();
  const utcDateAtNoon = Date.UTC(localDate.getFullYear(), localDate.getMonth(), localDate.getDate(), 12);
  return new Date(utcDateAtNoon);
}
function spread(props, fnc) {
  return fnc(props);
}
function spreadS(props, fnc) {
  return fnc(props);
}
function makeAzureFriendly(path) {
  return path.replace(/\//g, "___SL@SH___");
}
function undoAzureFriendly(path) {
  return path.replace(/___SL@SH___/g, "/");
}
const setTimeToStartOfDay = (0, _fp.set)({
  hours: 0,
  minutes: 0,
  seconds: 0,
  milliseconds: 0
});
exports.setTimeToStartOfDay = setTimeToStartOfDay;
const setTimeToMidday = (0, _fp.set)({
  hours: 12,
  minutes: 0,
  seconds: 0,
  milliseconds: 0
});
exports.setTimeToMidday = setTimeToMidday;
const setTimeToEndOfDay = (0, _fp.set)({
  hours: 23,
  minutes: 59,
  seconds: 59,
  milliseconds: 999
});
exports.setTimeToEndOfDay = setTimeToEndOfDay;
function todayAtNoon() {
  return setTimeToMidday(new Date());
}
function isBetween(minDate, maxDate) {
  return d => !(minDate && (0, _dateFns.isBefore)(d, minDate) || maxDate && (0, _dateFns.isAfter)(d, maxDate));
}
function isBetweenMidnightAndEndOfDay(minDate, maxDate) {
  return isBetween(minDate && setTimeToStartOfDay(minDate), maxDate && setTimeToEndOfDay(maxDate));
}
function arrayMove(arrInput, oldIndex, newIndex) {
  const arr = [...arrInput];
  while (oldIndex < 0) {
    oldIndex += arr.length;
  }
  while (newIndex < 0) {
    newIndex += arr.length;
  }
  if (newIndex >= arr.length) {
    let k = newIndex - arr.length + 1;
    while (k--) {
      arr.push(undefined);
    }
  }
  arr.splice(newIndex, 0, arr.splice(oldIndex, 1)[0]);
  return arr;
}
function arrayMoveDropUndefined(arrInput, oldIndex, newIndex) {
  return arrayMove(arrInput, oldIndex, newIndex).filter(x => x !== undefined);
}
function arMoveElDropUndefined(el, newIndex) {
  return arrInput => {
    const ar = [...arrInput];
    const index = ar.findIndex(x => x === el);
    if (index === -1) {
      return tsplus_module_1.none;
    }
    return tsplus_module_1.some(arrayMoveDropUndefined(ar, index, newIndex));
  };
}
function setMoveElDropUndefined(el, newIndex) {
  return arrInput => tsplus_module_1.map(ar => new Set(ar))([...arrInput]["|>"](arMoveElDropUndefined(el, newIndex)));
}
function isNativeTuple(a) {
  return Array.isArray(a);
}
const LazySymbol = Symbol("lazy");
exports.LazySymbol = LazySymbol;
function lazy(creator) {
  const key = Symbol(creator.name);
  const f = target => {
    let lazy = target[LazySymbol];
    if (!lazy) {
      lazy = {};
      Object.defineProperty(target, LazySymbol, {
        enumerable: false,
        value: lazy
      });
    } else if (lazy[key]) {
      return lazy[key];
    }
    const value = creator(target);
    lazy[key] = value;
    return value;
  };
  Object.defineProperty(f, "name", {
    enumerable: false,
    value: `Lazy<${creator.name}>`
  });
  return f;
}
//# sourceMappingURL=utils.cjs.map