import { Opt } from "@effect-ts-app/core/Option";
export declare function assertUnreachable(x: never): never;
export type OptPromise<T extends () => any> = (...args: Parameters<T>) => Promise<ReturnType<T>> | ReturnType<T>;
export declare const typedValuesOf: <T extends PropertyKey, T2>(obj: Record<T, T2>) => readonly T2[];
export declare function access<T extends string, T2>(t: Record<T, T2>): (key: T) => T2;
export declare function todayAtUTCNoon(): Date;
export declare function spread<Props extends Record<any, any>, NewProps>(props: Props, fnc: (props: Props) => NewProps): NewProps;
export declare function spreadS<Props extends Record<any, any>>(props: Props, fnc: (props: Props) => Props): Props;
export declare function makeAzureFriendly(path: string): string;
export declare function undoAzureFriendly<T extends string>(path: T): T;
export declare const setTimeToStartOfDay: CurriedFn1<number | Date, Date>;
export declare const setTimeToMidday: CurriedFn1<number | Date, Date>;
export declare const setTimeToEndOfDay: CurriedFn1<number | Date, Date>;
export declare function todayAtNoon(): Date;
export declare function isBetween(minDate?: Date, maxDate?: Date): (d: Date) => boolean;
export declare function isBetweenMidnightAndEndOfDay(minDate?: Date, maxDate?: Date): (d: Date) => boolean;
export declare function arrayMove<T>(arrInput: readonly T[], oldIndex: number, newIndex: number): (T | undefined)[];
export declare function arrayMoveDropUndefined<T>(arrInput: readonly (T | undefined)[], oldIndex: number, newIndex: number): T[];
export declare function arMoveElDropUndefined<T>(el: T, newIndex: number): (arrInput: ReadonlyArray<T | undefined>) => Opt<ReadonlyArray<T>>;
export declare function setMoveElDropUndefined<T>(el: T, newIndex: number): (arrInput: ReadonlySet<T | undefined>) => Opt<ReadonlySet<T>>;
export * from "@effect-ts-app/core/Function";
export * from "@effect-ts-app/core/utils";
export { default as get } from "lodash/get.js";
export { default as omit } from "lodash/omit.js";
export { default as pick } from "lodash/pick.js";
export type DistributiveOmit<T, K extends keyof any> = T extends any ? Omit<T, K> : never;
type RemoveNonArray<T> = T extends readonly any[] ? T : never;
export declare function isNativeTuple<A>(a: A): a is RemoveNonArray<A>;
export declare const LazySymbol: unique symbol;
export declare function lazy<T extends object, T2>(creator: (target: T) => T2): (target: T) => T2;
//# sourceMappingURL=utils.d.ts.map